<template>
  <div>
    <div class="titleBox">
      <div class="title">系统配置</div>
      <div class="btnBox">
        <el-button type="primary" @click="addConfig">
          <el-icon><CirclePlus /></el-icon>
          <span>新增</span>
        </el-button>
      </div>
    </div>
    <div class="searchBox" ref="searchBox">
      <el-form :model="listQuery" :inline="true">
        <el-form-item label="配置名称">
          <el-input
            placeholder="请输入配置名称"
            v-model="listQuery.configName"
            clearable
          ></el-input>
        </el-form-item>
        <el-form-item label="配置键">
          <el-input
            placeholder="请输入配置键"
            v-model="listQuery.configKey"
            clearable
          ></el-input>
        </el-form-item>

        <el-form-item>
          <el-button @click="handleFilter"> 查询 </el-button>
          <el-button @click="reset()"> 重置 </el-button>
        </el-form-item>
      </el-form>
    </div>
    <div class="tabBox">
      <el-table
        :data="tableData"
        border
        style="width: 100%"
        :height="tableHeight"
        :key="keyCount"
      >
        <el-table-column
          sortable
          prop="pzmc"
          show-overflow-tooltip
          label="配置名称"
        >
        </el-table-column>
        <el-table-column
          sortable
          prop="pzj"
          show-overflow-tooltip
          label="配置键"
        >
        </el-table-column>
        <el-table-column
          sortable
          prop="pzz"
          show-overflow-tooltip
          label="配置值"
        >
        </el-table-column>
        <el-table-column
          sortable
          prop="xtZhxgrxm"
          show-overflow-tooltip
          label="修改人姓名"
        >
        </el-table-column>
        <el-table-column sortable prop="bz" show-overflow-tooltip label="备注">
        </el-table-column>
        <el-table-column sortable prop="xtCjsj" label="采集时间">
          <template #default="{ row }">
            {{ $filters.dateFilter(row.xtCjsj) }}
          </template>
        </el-table-column>
        <el-table-column label="操作" fixed="right" width="160">
          <template #default="{ row }">
            <el-button @click="updateDict(row)" size="small">修改</el-button>
            <el-popconfirm
              confirm-button-text="是"
              cancel-button-text="否"
              icon-color="red"
              title="确定要删除?"
              @confirm="delConfig(row)"
            >
              <template #reference>
                <el-button type="danger" size="small">删除</el-button>
              </template>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>
      <div class="fenye" :style="{ top: tableHeight + 'px' }">
        <el-pagination
          class="pagination"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :current-page="listQuery.page"
          :page-sizes="[10, 20, 50, 100]"
          :page-size="listQuery.size"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total"
        >
        </el-pagination>
      </div>
    </div>
    <div v-if="dialogFormVisible" class="dialog">
      <div class="head_box">
        <span class="title">{{ isEdit ? "修改" : "新增" }}</span>
        <div>
          <!-- 修改 -->
          <el-button
            v-if="isEdit"
            type="primary"
            size="small"
            @click="onSave"
            :loading="buttonLoading"
            >保存</el-button
          >
          <!-- 新增 -->
          <el-button
            v-else
            type="primary"
            size="small"
            @click="onAdd"
            :loading="buttonLoading"
            >保存</el-button
          >
          <el-button size="small" @click="closeDialog">关闭</el-button>
        </div>
      </div>
      <el-form
        ref="formRef"
        class="mosty-from-wrap"
        :inline="true"
        label-position="top"
        :model="dialogForm"
        :rules="rules"
      >
        <el-form-item
          class="one"
          label="配置名称"
          prop="pzmc"
          label-width="140px"
        >
          <el-input
            v-model="dialogForm.pzmc"
            show-word-limit
            maxlength="50"
            autocomplete="off"
          ></el-input>
        </el-form-item>
        <el-form-item class="one" label="配置键" prop="pzj" label-width="140px">
          <el-input
            v-model="dialogForm.pzj"
            show-word-limit
            maxlength="50"
            autocomplete="off"
          ></el-input>
        </el-form-item>
        <el-form-item
          class="one"
          label="配置值"
          prop="pzz"
          required
          label-width="140px"
        >
          <el-input
            v-model="dialogForm.pzz"
            show-word-limit
            maxlength="50"
            autocomplete="off"
          ></el-input>
        </el-form-item>
        <!-- <el-form-item class="one" prop="xtZxbz" label="状态">
          <el-select
            style="width: 100%"
            v-model="dialogForm.xtZxbz"
            placeholder="请选择配置状态"
          >
            <el-option label="正常" :value="0"></el-option>
            <el-option label="注销" :value="1"></el-option>
          </el-select>
        </el-form-item> -->
        <el-form-item class="one" label="备注" label-width="140px">
          <el-input
            v-model="dialogForm.bz"
            :autosize="{ minRows: 2, maxRows: 4 }"
            type="textarea"
            show-word-limit
            maxlength="200"
          ></el-input>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script setup>
import { ElMessage } from "element-plus";
import { ref, reactive, onMounted, onUnmounted, getCurrentInstance } from "vue";
import {
  getSysConfigList,
  addSysConfig,
  updateSysConfig,
  deleteSysConfig
} from "@/api/user-manage";
const { proxy } = getCurrentInstance();
const keyCount = ref(0); //tabel组件刷新值
const searchBox = ref(null); // 搜索盒子
const tableHeight = ref(); // 表格高度
const formRef = ref(null);
const rules = ref({
  pzmc: [{ required: true, message: "请填写配置名称", trigger: "blur" }],
  pzj: [{ required: true, message: "请填写配置键", trigger: "blur" }],
  pzz: [{ required: true, message: "请填写配置值", trigger: "blur" }],
  xtZxbz: [{ required: true, message: "请选择配置状态", trigger: "blur" }],
});
//查询参数
const total = ref(0);
const page = ref(1);
const size = ref(20);
const currentRow = ref({});
const listQuery = ref({
  page: 1,
  size: 20,
  dictName: "",
  dictCode: "",
  xtZxbz: ""
});
const isEdit = ref(true);
const dialogForm = ref({});
const buttonLoading = ref(false);
// 数据相关
const tableData = ref([]);
const dialogFormVisible = ref(false);
const formLabelWidth = "140px";
// 获取数据的方法
const getListData = async () => {
  const params = listQuery.value;
  params.current = params.page;
  const res = await getSysConfigList(params);
  tableData.value = res?.records;
  total.value = Number(res.total);
};
const reset = () => {
  listQuery.value = {
    page: 1,
    size: 20,
    configName: "",
    configKey: ""
  };
  getListData();
};
const handleFilter = () => {
  listQuery.value.page = 1;
  getListData();
};
getListData();

// 分页相关
/**
 * size 改变触发
 */
const handleSizeChange = (currentSize) => {
  listQuery.value.size = currentSize;
  getListData();
};

/**
 * 页码改变触发
 */
const handleCurrentChange = (currentPage) => {
  listQuery.value.page = currentPage;
  getListData();
};

/**修改字典 */
const updateDict = (row) => {
  isEdit.value = true;
  dialogForm.value = { ...row };
  dialogFormVisible.value = true;
};

const addConfig = (row) => {
  isEdit.value = false;
  dialogForm.value = {};
  dialogFormVisible.value = true;
};
const onSave = () => {
  formRef.value.validate((valid) => {
    if (!valid) {
      ElMessage.error("请完成必填项！");
      return false;
    }
    buttonLoading.value = true;
    updateSysConfig({
      ...dialogForm.value
    })
      .then((res) => {
        dialogFormVisible.value = false;
        ElMessage.success("修改成功");
        handleFilter();
      })
      .finally(() => {
        buttonLoading.value = false;
      });
  });
};

const onAdd = () => {
  formRef.value.validate((valid) => {
    if (!valid) {
      ElMessage.error("请完成必填项！");
      return false;
    }
    buttonLoading.value = true;
    addSysConfig({
      ...dialogForm.value
    })
      .then((res) => {
        dialogFormVisible.value = false;
        ElMessage.success("新增成功");
        handleFilter();
      })
      .finally(() => {
        buttonLoading.value = false;
      });
  });
};

const delConfig = (row) => {
  deleteSysConfig({
    id: Number(row.id)
  }).then((res) => {
    ElMessage.success("删除成功");
    handleFilter();
  });
};

const closeDialog = () => {
  dialogForm.value = {};
  dialogFormVisible.value = false;
};
// 表格高度计算
const tabHeightFn = () => {
  tableHeight.value = window.innerHeight - searchBox.value.offsetHeight - 240;
};
onMounted(() => {
  tabHeightFn();
  window.onresize = function () {
    tabHeightFn();
  };
  proxy.mittBus.on("mittFn", (data) => {
    keyCount.value = data;
  });
});
onUnmounted(() => {
  proxy.mittBus.off("mittFn");
});
</script>

<style lang="scss" scoped>
@import "~@/assets/css/layout.scss";
@import "~@/assets/css/element-plus.scss";
.user-manage-container {
  .table-header-wrap {
    margin-bottom: 22px;
  }

  ::v-deep .avatar {
    width: 60px;
    height: 60px;
    border-radius: 50%;
  }

  ::v-deep .el-tag {
    margin-right: 6px;
  }

  .pagination {
    margin-top: 20px;
  }
}
</style>
